unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

// arctan
// 1 z甽Α̊pxvZ
// IngEIC[̌vZ
function arctan_routine(x: double): double;
var
  i : integer;
  ax, y, ans, bans, f: double;
begin
  ax := x;
  if x > 1 then ax := 1 / x;
  y := (ax * ax)/(1 + ax * ax);
  i := 1;
  ans := 1;
  f := 1;
  repeat
    bans := ans;
    f := f * i * 2 / (i * 2 + 1) * y;
    ans := ans  + f;
    inc(i);
  until (bans = ans) or (i > 10000);
  ans := ans  * y / ax;
  if x > 1 then ans := pi / 2 - ans;
  result := ans;
  form1.Memo1.Lines.Append('  Loop= ' + intTostr(i-1));
end;

// 1 z甽Α̊pxvZ
function arctanM_routine(x: double): double;
var
  i : integer;
  tx, ans, bans, f: double;
begin
  tx := x;
  if x > 1 then tx := 1 / x;
  ans := tx;
  f := tx;
  i := 1;
  repeat
    bans := ans;
    f := - f * tx * tx;
    ans := ans  + f / (i * 2 + 1);
    inc(i);
  until (bans = ans) or (i > 10000000);
  if x > 1 then ans := pi / 2 - ans;
  result := ans;
  form1.Memo1.Lines.Append('  Loop= ' + intTostr(i-1));
end;

// arcsin
// x̒l0.999999ʂx
function arcsin_routine(x: double): double;
label
  EXT;
var
  i : integer;
  ans, bans, f, d: double;
begin
  i := 1;
  if x = 1 then begin
    result := pi / 2;
    goto EXT;
  end;
  f := 1 / 2;
  d := x * x * x;
  ans := (x + f * d / 3);
  repeat
    bans := ans;
    d := d * x * x;
    f := f * (i * 2 + 1) / ((i + 1) * 2);
    ans := ans + f * d / (i * 2 + 3);
    inc(i);
  until (bans = ans) or (i > 10000000);
  result := ans;
EXT:
  form1.Memo1.Lines.Append('  Loop= ' + intTostr(i - 1));
end;

// 0.7𒴂甽Α̊px߂܂(cosvZɂȂ܂)
function arcsinM_routine(x: double): double;
label
  EXT;
var
  i : integer;
  ax, ans, bans, f, d: double;
begin
  i := 1;
//  if x = 1 then begin
//    result := pi / 2;
//    goto EXT;
//  end;
  ax := x;
  if x > 0.7 then ax := sqrt(1 - x * x);
  f := 1 / 2;
  d := ax * ax * ax;
  ans := (ax + f * d / 3);
  repeat
    bans := ans;
    d := d * ax * ax;
    f := f * (i * 2 + 1) / ((i + 1) * 2);
    ans := ans + f * d / (i * 2 + 3);
    inc(i);
  until (bans = ans) or (i > 1000);
  if x > 0.7 then ans := pi / 2 - ans;
  result := ans;
EXT:
  form1.Memo1.Lines.Append('  Loop= ' + intTostr(i - 1));
end;

// arctan vZ
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch : integer;
  x, ax, at, deg : double;
begin
  val(Labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢ܂B','',0);
    exit;
  end;
  Memo1.Clear;
  ax := abs(x);
  at := arctan_routine(ax);
  if x < 0 then at := -at;
  deg := at / pi * 180;
  Memo1.Lines.Append('  aectan(x) = ' + floatTostr(deg));
  at := arctanM_routine(ax);
  if x < 0 then at := -at;
  deg := at / pi * 180;
  Memo1.Lines.Append('  aectan(x) = ' + floatTostr(deg));
end;

// arcsin vZ
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch : integer;
  x, ax, asi, deg : double;
begin
  val(Labelededit2.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢ܂B','',0);
    exit;
  end;
  if abs(x) > 1 then begin
    application.MessageBox('͒l傫܂B(X  1)','',0);
    exit;
  end;
  Memo1.Clear;
  ax := abs(x);
  asi := arcsin_routine(ax);
  if x < 0 then asi := -asi;
  deg := asi / pi * 180;
  Memo1.Lines.Append('  aecsin(x) = ' + floatTostr(deg));
  asi := arcsinM_routine(ax);
  if x < 0 then asi := -asi;
  deg := asi / pi * 180;
  Memo1.Lines.Append('  aecsin(x) = ' + floatTostr(deg));
end;

end.
